<?php
$lib_common = '../../../lib-common.php';
include($lib_common);

// Only let admin users access this page
if (!SEC_inGroup('Root')) {    
// Someone is trying to illegally access this page
    COM_errorLog("Someone has tried to illegally access the Weather plugin install documentation.  User id: {$_USER['uid']}, Username: {$_USER['username']}, IP: $REMOTE_ADDR",1);
    $display = COM_siteHeader();
    $display .= COM_startBlock($LANG_GW00['access_denied']);
    $display .= $LANG_GW00['access_denied_msg'];
    $display .= COM_endBlock();
    $display .= COM_siteFooter(true);
    echo $display;
    exit;
}       

include('../../../weather/phpweather.inc'); 

global $_TABLES, $HTTP_POST_VARS, $metar;

$metar = $HTTP_POST_VARS['metar'];

if(empty($metar)){
	
	$sql = "select metar from {$_TABLES['weather']} where wdefault=1";
	$row = DB_fetchArray(DB_query($sql));
	$metar = $row[metar];
}	


echo COM_siteHeader();
echo COM_startBlock('Metar Data Check');
echo "This page will verify the data in the METAR.  You can use this page to confirm that the values displayed on the weather block 
are accurate.</p>";

echo "Displaying data for METAR&nbsp;:";
echo "<b>";
echo $metar;
echo "</b><p>";
                  
$data = process_metar(get_metar($metar));
echo "<pre>\n";                          
print_r($data);                          
echo "</pre>\n"; 
echo "<p>";
echo "<form method=\"POST\" action=\"array.php\">";
echo "Test Metar:";
echo "&nbsp;<INPUT type=\"text\" name=\"metar\">";
echo "&nbsp;<INPUT type=\"submit\" value=\"Submit\">";	
echo "</form>";
echo COM_endBlock();
echo COM_siteFooter(false);  
                     
?>                                       