<?php
//
// +---------------------------------------------------------------------------+
// | generic Plugin 1.0 for Geeklog - The Ultimate Weblog                      |
// +---------------------------------------------------------------------------+
// | config.php                                                                |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2002 by the following authors:                              |
// |                                                                           |
// | Author:                                                                   |
// | Constructed with the Universal Plugin                                     |
// | Copyright (C) 2002 by the following authors:                              |
// | Tom Willett                 -    twillett@users.sourceforge.net           |
// | Blaine Lang                 -    langmail@sympatico.ca                    |
// | The Universal Plugin is based on prior work by:                           |
// | Tony Bibbs                  -    tony@tonybibbs.com                       |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+
//


//PROXY SETTINS

// This lets you configure a proxy. If you want to use a proxy, set to 1.
$_GW_use_proxy = 0;

// If using proxy, set this variable to the ip-number or hostname of the proxy.
$_GW_proxy_host = 'proxy.your-isp.com';

// If using proxy, change the port, if necessary. The popular Squid proxy defaults to port 3128, but port 80 or 8080 is also commonly used.
$_GW_proxy_port = 3128;


//USER SETTINS

// Set global default weather temp
$_GW_default_tp = 'F'; //C for Celsius

// Controls the weather block display
$_GW_showform = 0;  //show location drop down box.  1 = on | 0 = off

// Set to 1 to show block render time stats in seconds
$_GW_show_stats = 0;  //1 = on 0 = off

// This replaces title icons with text using class="middleboxtitle" in style.css
$_GW_replace_title_images = true; // false; leaves title images as local icons

// default cache life
$_GW_cache_life = 50; //minutes

//Block ordering on page
$_GW_blockorder = 10; //Can be any number 1-255

//Set block on left side
$_GW_onleft = 0; //1 = left | 0 = right

//ERROR SETTINGS

// How long before your connection times out trying to reach the metar?\
$_GW_timeout = 10; // in seconds, you can use decimals ie .05.

// Do you want to log in your error log when it timeouts
$_GW_errorlogging = true; // false; does not log messages to your error log

// Do you want the weather block to be removed if a timeout occurs
$_GW_removeblock = true; // false; leaves the block on your site if an error occurs

// Do you want to display an error block if the weather block is removed Note:  $_GW_removeblock MUST also be true!
$_GW_showerrorblock = true; // false; does nothing if an error occurs

//Error block message
$_GW_errorblockmsg = 'Sorry, the weather block is unavailable.  Please check back soon.';

// Send email if the weather block is removed
$_GW_sendemail = true; //false; does not send email notification if block is removed

//Send notification to this person
$_GW_toemail = 'you@somewhere.com';

// Error email subject
$_GW_subject = 'Weather Block Error';

//Error email content
$_GW_content = 'The Weather Block has been removed from your site.  Please go to '. $_CONF['site_url'].'/admin/plugins/weather/index.php to reinstall the block.  You may also want to check your error log for timeout errors.';

// +---------------------------------------------------------------------------+
// DON'T CHANGE ANY OF THE BELOW					       |
// +---------------------------------------------------------------------------+

// Set Weather Plugin Table Prefix the Same as Geeklogs
$_GW_table_prefix = $_DB_table_prefix;

// Add Weather Plugin tables to $_TABLES array
$_TABLES['weather']		= $_GW_table_prefix . 'weather';
$_TABLES['weather_cache']	= $_GW_table_prefix . 'weather_cache';
$_TABLES['weather_forecast']	= $_GW_table_prefix . 'weather_forecast';
$_TABLES['weather_us_states']	= $_GW_table_prefix . 'weather_us_states';
$_TABLES['weather_scratch']	= $_GW_table_prefix . 'weather_scratch';
$_TABLES['weather_user']	= $_GW_table_prefix . 'weather_user';

// URL to weather directory on your server
// Uses Geeklog variable for site url
$_GW_sw_site = $_CONF['site_url'] . '/weather/';

// URL to icons on your server
$_GW_sw_iconpath = $_CONF['site_url'] . '/weather/images';

// File to back link to
$_GW_sw_file = 'index.php';
?>
