<?PHP
/*
This is based on the phpWebsite weather module
by spiggy, thecat@merciless.net
http://phpgirl.com/mod.php?mod=spiggy&menu=2404
*/


/*
REVISED 2003-07-17 to fix more local wx and 2-day links
*/


// load geeklog common stuff
include('../lib-common.php');
include('../../plugins/weather/config.php');
include('../../plugins/weather/language/english.php');

// determine current time
// used to compare with stored cache
  $date_unixtime = time();
  $date = date('YmdHis', $date_unixtime);
  
//replace title images
function replace_titleimages($html)
{
global $strings;

$table_start = '<table width="100%" cellspacing="1" cellpadding="0"><tr><td class="middleboxtitle"><center>';
$table_end = '</td></tr><tr><td class="line"></td></tr></center></table>';
$html = str_replace('<img src="/weather/images/fcicons/7dayfcst.jpg" width="660" height="20" border="0" alt="7-Day Forecast">', $table_start . $strings['7day'] . $table_end, $html);
$html = str_replace('<img src="/weather/images/fcicons/fcst.jpg" width="326" height="20" border="0" alt="Detailed Forecast">', $table_start . $strings['detailed'] . $table_end, $html);
$html = str_replace('<img src="/weather/images/fcicons/currentconds.jpg" width="326" height="20" border="0" alt="Current local weather">', $table_start . $strings['local'] . $table_end, $html);
$html = str_replace('<img src="/weather/images/fcicons/radandsat.jpg" width="326" height="20" border="0" alt="Radar and Satellite images - Click to enlarge">', $table_start . $strings['radar'] . $table_end, $html);
$html = str_replace('<img src="/weather/images/fcicons/addinfosml.jpg" width="326" height="20" border="0" alt="Additional Information">', $table_start . $strings['additional'] . $table_end, $html);
// alternate format

$html = str_replace('<img src="/weather/images/fcicons/7dayfcst.jpg" width=660 height=20 border=0 alt="7-Day Forecast">', $table_start . $strings['7day'] . $table_end, $html);
$html = str_replace('<img alt="7-Day Forecast"       src="/weather/images/fcicons/7dayfcst.jpg" border=0 width="660" height="20">', $table_start . $strings['7day'] . $table_end, $html);
$html = str_replace('<img alt="Detailed Forecast"       src="/weather/images/fcicons/fcst.jpg" border=0 width="326" height="20">', $table_start . $strings['detailed'] . $table_end, $html);
$html = str_replace('<img alt="Current local weather"       src="/weather/images/fcicons/currentconds.jpg" border=0 width="326" height="20">', $table_start . $strings['local'] . $table_end, $html);
$html = str_replace('<img       alt="Radar and Satellite images - Click to enlarge"       src="/weather/images/fcicons/radandsat.jpg" border=0 width="326" height="20">', $table_start .  $strings['radar'] . $table_end, $html);
$html = str_replace('<img alt="Additional Information"             src="/weather/images/fcicons/addinfosml.jpg" border=0 width="326" height="20">', $table_start . $strings['additional'] . $table_end, $html);
// alternate format
$html = str_replace('<img alt="Radar and Satellite images - Click to enlarge"       src="/weather/images/fcicons/radandsat.jpg" border=0 width="326" height="20">', $table_start . $strings['radar'] . $table_end, $html);

$html = str_replace('</h3><br />', '</h3>', $html);
return $html;
}

  
//cleans up the NOAA web page for local display
function cleanup_html($html)
{
    global $_GW_sw_site, $_GW_sw_file, $_GW_sw_iconpath, $_GW_replace_title_images, $_CONF, $PHP_SELF;
    
    $html = str_replace( 'href="credits.htm"', 'href="http://weather.gov/credits.html"', $html );
    $html = str_replace( 'http://www.srh.noaa.gov/weather/images/fcicons/', $_GW_sw_iconpath.'/', $html );
    $html = str_replace( 'http://www.srh.noaa.gov/weather/images/fcicons/', $_GW_sw_iconpath.'/', $html );
    //$html = str_replace( 'http://www.srh.noaa.gov/obslocal.php?', $wx[site_site] . $_GW_sw_file . '?goget=obslocal.php&', $html );
    $html = str_replace( 'href="/obslocal.php?', 'href="' . $_GW_sw_site . $_GW_sw_file . '?goget=obslocal.php&', $html );
    //$html = str_replace( 'http://www.srh.noaa.gov/obshistory.php?', $wx[site_site] . $_GW_sw_file . '?goget=obshistory.php&', $html );
    $html = str_replace( 'href="/data/obhistory/', 'href="' . $_GW_sw_site . $_GW_sw_file . '?goget=obshistory&locale=', $html );
    $html = str_replace( '/cgi-bin/wrhq', 'http://www.wrh.noaa.gov/cgi-bin/wrhq', $html );
    $html = str_replace( 'class="big"', 'style="font-size: 12px; font-weight: bold"', $html );
    $html = str_replace( 'class="blue1"', 'style="font-size: 12px; font-weight: bold"', $html );
    $html = preg_replace('/( bgcolor=[\'"]?.*?[\'"]?)>/', '>', $html);
    $html = preg_replace('/( bgColor=[\'"]?.*?[\'"]?)>/', '>', $html);
    $html = preg_replace('/( BGCOLOR=[\'"]?.*?[\'"]?)>/', '>', $html);
    $html = str_replace( '<td><td', '<td', $html );
    $html = str_replace( '</form>', '', $html );
    $html = str_replace( '&' , '&amp;', $html );
    $html = str_replace( '&amp;deg;', '&deg;', $html );
    $html = str_replace( '&amp;quot;', '&quot;', $html );
    $html = str_replace( '&amp;ordm;', '&ordm;', $html );
    $html = str_replace( '<th', '<td ', $html );
    $html = str_replace( '<td><span', '<td align="center"><span', $html );
    $html = str_replace( 'noshade', 'noshade="noshade"', $html );
    $html = str_replace( 'nowrap', 'nowrap="nowrap"', $html );
    $html = preg_replace("/(<table [^\>]*?)>/s", '<table width="100%">', $html);
    $html = preg_replace("/(<font [^\>]*?)>/s", '', $html);
    $html = str_replace("</font>", '', $html);
    $html = preg_replace('/<\/table>[[:space:]]?<table [^\>]*>[[:space:]]?<\/td>[[:space:]]?<\/tr>/s', "", $html);
    $html = str_replace('http://www.seawfo.noaa.govhttp://www.wrh.noaa.gov/', 'http://www.seawfo.noaa.gov/', $html );
    $html = str_replace( '<br>()', '(local)', $html );
// check whether to replace title images
If ($_GW_replace_title_images)
{
  $html = replace_titleimages($html);
} ELSE {
  $html = str_replace( 'src="/weather/images/fcicons/','src="' . $_GW_sw_iconpath.'/', $html );
}
return $html;
}

// get weather page for zip
function get_noaa_page($url)
{
global $_TABLES, $_GW_cache_life, $url, $weather_data, $date, $msg, $strings;

//Get weather info as an array of html";
$content_array = file($url);
$count = count($content_array);

// look for the bottom of the header info
$ready=false;
$look_for_submit='<input type';
$look_for_table="<table";
for ($i = 0; $i < $count; $i++)
{
  $this_line=strtolower($content_array[$i]);
  $pos_submit = strpos($this_line,$look_for_submit); 
  $pos_border = strpos($this_line,$look_for_table);
  
  // if submit is found
  if ($pos_submit !== false)
  {
   $ready=true;
  } 
  
  // after we find submit, if we find border
  if (($ready) && ($pos_border !== false))
  {
   $slice = $i;
   break;
  } // if ready
} //for

//slice off the top lines
$content_array = array_slice($content_array, $slice);
//merge into one big string
$content_array = implode('',$content_array);
//strip unwanted charaters
$content_array = str_replace("\n",'',$content_array);
$content_array = str_replace("\r",'',$content_array);
$content_array = str_replace("|",'',$content_array);
$content_array = str_replace("<IMG ",'<img ',$content_array);
//finish localizing content
$html = cleanup_html($content_array);
$weather_data .= "$html";

return $weather_data;
}

function add_cache($weather_data,$date,$zip)
{
global $_TABLES, $_GW_cache_life, $url, $weather_data, $date, $msg, $zip, $strings;
//add weather data to database   
//addslashes is used to eliminate sql errors
//problem didn't occur all the time; just for certain zip codes
$stored_data = addslashes($weather_data);

//replace data in database
// if zipcode already exists the data is freshened
// if zipcode doesn't already exist in database, data is inserted
// zip in table must be set as unique index for this to work.
$sql = "
REPLACE INTO {$_TABLES['weather_forecast']} SET `timestamp` = '$date',`cache` = '$stored_data', `zip` = '$zip'
";

$result = DB_query($sql);
$nrows = DB_numRows($result);

$msg .= "<div align='center'>";
$msg .= $strings['local_data'];
$msg .= "&nbsp;$_GW_cache_life minutes.<br></div>";

}// end function 

//MAIN PROCESS WORK DONE HERE
//Check for get value
//If nothing found use zip 
$goget = $_GET['goget'];

switch ($goget)
{
case 'obslocal.php':
$url = 'http://www.srh.noaa.gov/' . $goget . '?warnzone=' . $_GET['warnzone'] . '&offset=' . $_GET['offset'];
get_noaa_page($url);
break;
case 'obshistory':
$url = 'http://www.srh.noaa.gov/data/' . $goget . '/' . $_GET['locale'];
get_noaa_page($url);
break;
default:
//Check to see if alternative zip has been posted
//URL would be yoursite.com/weather/index.php?zip=90210
global $_CONF, $_USER, $HTTP_GET_VARS, $strings;

//Check to see if alternative zip has been posted
//URL would be yoursite.com/weather/index.php?zip=90210
if (empty($_POST['zip']))
{
//no post zip specified
    $zip = $HTTP_GET_VARS['zip'];     
} ELSE {
//zip specified
    $zip = $_POST['zip'];
}

//bad hack for two part form
if (!empty($_POST['zip_code']) && empty($_POST['zip']))
{  
    $zip = $_POST['zip_code'];
}     	

//use default if no zip specified
if (empty($zip)){
$sql = "select zip from {$_TABLES['weather']} where wdefault=1";
$row = DB_fetchArray(DB_query($sql));	
$zip = $row[zip]; 
}  

$url="http://www.srh.noaa.gov/zipcity.php?inputstring=".$zip;

// TIMESTAMP check
if (empty($timestamp))
{
//no match was found in database for requested zip
   get_noaa_page($url);
   add_cache($weather_data, $date, $zip);
   
} ELSE {
//found existing data for requested zip
  $cache_age = date('YmdHi', $timestamp);
  $minutes_old = round(($date-$timestamp)/60);
  
// check for old cache
  if ($minutes_old > $_GW_cache_life)
  {
// get new data to replace old
    get_noaa_page($url);
    add_cache($weather_data ,$date, $zip);
  } ELSE {
// retrieve data from cache
$sql = "select cache from {$_TABLES['weather_forecast']} where zip='$zip'";
$row = DB_fetchArray(DB_query($sql));
$weather_data = $row[cache];

$msg .= "<div align=\"center\">";
$msg .= $strings['old_data'];
$msg .= "&nbsp;$minutes_old&nbsp;";
$msg .= $strings['old_data2'];
$msg .= "&nbsp;$_GW_cache_life&nbsp;";
$msg .= $strings['old_data3']; 
$msg .= "<br></div>";
  }
  
} // end TIMESTAMP check

} // switch


function weather_search($zip)
{

global $_CONF, $_USER, $HTTP_USER_AGENT, $_TABLES, $strings;
	
// Browser & Platform Check
if(@eregi("(opera) ([0-9]{1,2}.[0-9]{1,3}){0,1}",$HTTP_USER_AGENT,$match) || @eregi("(opera/)([0-9]{1,2}.[0- 9]{1,3}){0,1}",$HTTP_USER_AGENT,$match))
{
$BName= "Opera"; $BVersion=$match[2];
}
elseif(eregi("(msie) ([0-9]{1,2}.[0-9]{1,3})",$HTTP_USER_AGENT,$match))
{
$BName = "MSIE"; $BVersion=$match[2];
}
if ($BName=='MSIE' || $BName=='Opera') {
//weather zip search box
$weather_search.= "<table width=\"100%\"><tr>";
$weather_search.= "<td align=left valign=top>";
$go = $strings['go_button'];
$sql = "select zip,location from {$_TABLES['weather']} where wforecast='1' order by location";	
$query = DB_query($sql);
$weather_search.= "<form action=\"" . $_CONF['site_url'] . "/weather/index.php\" method=\"post\">";
$weather_search.= $strings['more_forecast'];
$weather_search.= "<br><br>";
$weather_search.= $strings['city_form2'];
$weather_search.= "&nbsp;<select name=\"zip_code\" onChange=\"submit()\">";
$weather_search.= "<option selected>";
$weather_search.= $strings['city_form'];
$weather_search.="</option>";
while ($row = DB_fetchArray($query)) {
		$weather_search.= "<option value=\"$row[zip]\">$row[location]</option>";
       }
$weather_search.= "</select>&nbsp;&nbsp;";
$weather_search.= $strings['search_form'];
$weather_search.= "&nbsp;<input type=\"text\" name=\"zip\" size=\"5\" maxlength=\"5\">";
$weather_search.= "&nbsp;<input type=\"submit\" value=\"$go\"></form>";
$weather_search.= "</td>";

$weather_search.= "<td align=right valign=top>";	
if (($_USER['uid'] > 0)) {
    if (!empty($zip)){
	$sql = "select zip,location,metar from {$_TABLES['weather']} where zip='$zip'";	
	$row = DB_fetchArray(DB_query($sql));
	$location = $row[location];
	$metar = $row[metar];
	if (!empty($location)){
		if ($metar==$_USER['weather_metar']){			
			$weather_search.=$strings['current'];
			$weather_search.= "&nbsp;$location.<br><br>";						
	                $weather_search.= "<a href=\"" . $_CONF['site_url'] . "/weather/admin.php\">";
			$weather_search.= $strings['my_weather'];
			$weather_search.="</a>";
		} else {
			$sql = "select location from {$_TABLES['weather']} where metar='" .$_USER['weather_metar']."'";	
			$row = DB_fetchArray(DB_query($sql));
			$default = $row[location];					
			$weather_search.=$strings['current'];
			$weather_search.= "&nbsp;$default.<br><br>";
			$weather_search.= "<a href=\"index.php?op=set_as_user_default&zip=$zip\">";
			$weather_search.=$strings['my_default2'];
			$weather_search.= "&nbsp;$location&nbsp;";
			$weather_search.=$strings['my_default3'];
			$weather_search.="</a>";
			$weather_search.= "&nbsp;|&nbsp;";
			$weather_search.= "<a href=\"" . $_CONF['site_url'] . "/weather/admin.php\">";
			$weather_search.= $strings['my_weather'];
			$weather_search.="</a>";
		}				   
	} else {	
		$weather_search.= "<a href=\"" . $_CONF['site_url'] . "/weather/admin.php\">";
		$weather_search.= $strings['my_weather'];
		$weather_search.="</a>";	
       }		
		
    } else {
           $weather_search.= "<a href=\"" . $_CONF['site_url'] . "/weather/admin.php\">";
	   $weather_search.= $strings['my_weather'];
	   $weather_search.="</a>";	      	
   } 	   
}
$weather_search.= "</td></tr></table>";

} else {

$weather_search.= "<table width=\"100%\"><tr>";
$weather_search.= "<td align=left valign=top>";
$go = $strings['go_button'];
$sql = "select zip,location from {$_TABLES['weather']} where wforecast='1' order by location";	
$query = DB_query($sql);
$weather_search.= "<form action=\"" . $_CONF['site_url'] . "/weather/index.php\" method=\"post\">";
$weather_search.= $strings['more_forecast'];
$weather_search.= "<br><br>";
$weather_search.= $strings['city_form2'];
$weather_search.= "&nbsp;<select name=\"zip_code\">";
$weather_search.= "<option selected>";
$weather_search.= $strings['city_form'];
$weather_search.="</option>";
while ($row = DB_fetchArray($query)) {
		$weather_search.= "<option value=\"$row[zip]\">$row[location]</option>";
       }
$weather_search.= "</select>&nbsp;<input type=\"submit\" value=\"$go\">&nbsp;&nbsp;";
$weather_search.= $strings['search_form'];
$weather_search.= "&nbsp;<input type=\"text\" name=\"zip\" size=\"5\" maxlength=\"5\">";
$weather_search.= "&nbsp;<input type=\"submit\" value=\"$go\"></form>";
$weather_search.= "</td>";

$weather_search.= "<td align=right valign=top>";	
if (($_USER['uid'] > 0)) {
    if (!empty($zip)){	
	$sql = "select zip,location,metar from {$_TABLES['weather']} where zip='$zip'";	
	$row = DB_fetchArray(DB_query($sql));
	$location = $row[location];
	$metar = $row[metar];
	if (!empty($location)){
		if ($metar==$_USER['weather_metar']){
			$weather_search.=$strings['current'];
			$weather_search.= "&nbsp;$location.<br><br>";						
	                $weather_search.= "<a href=\"" . $_CONF['site_url'] . "/weather/admin.php\">";
			$weather_search.= $strings['my_weather'];
			$weather_search.="</a>";
		} else {							
			$sql = "select location from {$_TABLES['weather']} where metar='" .$_USER['weather_metar']."'";	
			$row = DB_fetchArray(DB_query($sql));
			$default = $row[location];					
			$weather_search.=$strings['current'];
			$weather_search.= "&nbsp;$default.<br><br>";
			$weather_search.= "<a href=\"index.php?op=set_as_user_default&zip=$zip\">";
			$weather_search.=$strings['my_default2'];
			$weather_search.= "&nbsp;$location&nbsp;";
			$weather_search.=$strings['my_default3'];
			$weather_search.="</a>";
			$weather_search.= "&nbsp;|&nbsp;";
			$weather_search.= "<a href=\"" . $_CONF['site_url'] . "/weather/admin.php\">";
			$weather_search.= $strings['my_weather'];
			$weather_search.="</a>";
		}				   
	} else {	
		$weather_search.= "<a href=\"" . $_CONF['site_url'] . "/weather/admin.php\">";
		$weather_search.= $strings['my_weather'];
		$weather_search.="</a>";	
       }
   } else {
           $weather_search.= "<a href=\"" . $_CONF['site_url'] . "/weather/admin.php\">";
	   $weather_search.= $strings['my_weather'];
	   $weather_search.="</a>";	      	
   }    		
}
$weather_search.= "</td></tr></table>";

}
return $weather_search;

}//end funciton

switch ($op) {

case "set_as_user_default":
   set_as_user_default($zip); 
   break;
}

function set_as_user_default($zip){
	global $_TABLES, $_USER, $strings;
	
	$sql = "select metar from {$_TABLES['weather']} where zip='$zip'";
	$row = DB_fetchArray(DB_query($sql));
	$metar = $row[metar];		
	$sql = "update {$_TABLES['userprefs']} set weather_metar='" . $metar . "' where uid='" . $_USER['uid'] . "'";
	DB_query($sql);
	$_USER['weather_metar'] = $metar;
	
	//page redirect
	$save = $strings['save'];	
	redirect_header("" . $_CONF['site_url'] . "/weather/index.php?zip=$zip",1,"$save");	
 	exit();	
}	 

//Code from Blaine
function redirect_header($url, $time=4, $message=""){
    
    global $strings;
    
    $redir_msg = $strings['redirect'];
    $here = $strings['here'];	
	
    define("_IFNOTRELOAD","$redir_msg <a href=%s>$here</a>.");
	echo "<html><head>\n";
	echo "<meta http-equiv='Content-Type' content='text/html;' />\n";
	echo "<meta http-equiv='Refresh' content='$time; url=$url' />\n";
	echo "</head><body><div id='content'>\n";
	echo COM_siteHeader(menu);
	echo COM_startBlock($strings['admin_block']);			
	echo "<center><br/><b>\n";	
	echo $message;
	echo "<p>";
	printf(_IFNOTRELOAD,$url);
	echo "</b>\n";
	echo "</div></center>\n";
	echo COM_endBlock();
	echo COM_siteFooter(true);
}

//echo $zip;
$display = COM_siteHeader('menu');
$display .= COM_startBlock($strings['details_block']);
$display .= weather_search($zip);
$display .= "<!-- START WEATHER DATA -->";
$display .= "<table width=\"100%\"><tr><td colspan=\"3\" valign=top><hr width=\"100%\" size=\"2\" noshade=\"noshade\"></td></tr>";
$display .= $weather_data;
$display .= "<!-- END WEATHER DATA -->";
$display .= $msg;
$display .= COM_endBlock();
$display .= COM_siteFooter();
echo $display;
?>
