<?php

// +---------------------------------------------------------------------------+
// | Universal Geeklog Plugin 1.0                                              |
// +---------------------------------------------------------------------------+
// | admin/index.php                                                           |
// | Administration page.                                                      |
// |                                                                           |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2002 by the following authors:                              |
// |                                                                           |
// | Author:                                                                   |
// | Constructed with the Universal Plugin                                     |
// | Copyright (C) 2002 by the following authors:                              |
// | Tom Willett                 -    twillett@users.sourceforge.net           |
// | Blaine Lang                 -    langmail@sympatico.ca                    |
// | The Universal Plugin is based on prior work by:                           |
// | Tony Bibbs                  -    tony@tonybibbs.com                       |
// +---------------------------------------------------------------------------+
// | Replace all weather with the name of your plugin and you have a skeletal |
// | admin page.                                                               |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+
//

require_once('../../../lib-common.php');
require_once($_CONF['path'] . 'plugins/weather/functions.inc');
require_once($_CONF['path'] . 'plugins/weather/config.php');

global $_GW_showerrorblock, $_GW_blockorder, $_GW_onleft;

// Only let admin users access this page
if (!SEC_hasRights('weather.admin')) {
    // Someone is trying to illegally access this page
    COM_errorLog("Someone has tried to illegally access the Weather Admin page.  User id: {$_USER['uid']}, Username: {$_USER['username']}, IP: $REMOTE_ADDR",1);
    $display = COM_siteHeader();
    $display .= COM_startBlock($LANG_GW00['access_denied']);
    $display .= $LANG_GW00['access_denied_msg'];
    $display .= COM_endBlock();
    $display .= COM_siteFooter(true);
    echo $display;
    exit;
}
 
/**
* Main 
*/


$display .= COM_siteHeader();
$display .= COM_startBlock ($strings['admin_home']);
// put your code here

//check to see if block is installed...
        $sql = "select is_enabled from {$_TABLES['blocks']} where phpblockfn = 'phpblock_getweather'";
                $row = DB_fetchArray(DB_query($sql));
                $is_enabled = $row[is_enabled];               
                                              
        if ($is_enabled != 1) {
        $display .="<P>";    
        $display .= "<font color=\"red\">WARNING...Weather Block is not installed or disabled.  Click <a href=\"index.php?loadblock=yes\">here</a> to install the block!";
        $display .= " Check your error log to see why the block was removed.</font><p>";
        }

switch ($loadblock) {

 case "yes":
	 install_block(); 
	 break;
}

function install_block (){
global $_TABLES, $_GW_showerrorblock, $_GW_blockorder, $_GW_onleft;

    	$query = "INSERT
    	          INTO {$_TABLES['blocks']} (is_enabled, name, type, title, tid, blockorder, onleft, phpblockfn, group_id, owner_id, perm_owner, perm_group, perm_members, perm_anon)
    	          VALUES ('1','Weather','phpblock','Weather','all',$_GW_blockorder,$_GW_onleft,'phpblock_getweather',2,2,3,3,2,2)";
   	$result = DB_query($query);  	
   	
   	
   	if ($_GW_showerrorblock == 'true') {
   	    COM_errorLog("Remove Weather - Block Error Definition ", 1);
   	    $sql = "select is_enabled from {$_TABLES['blocks']} where type='normal' && title='Weather'";
                $row = DB_fetchArray(DB_query($sql));
                $is_enabled = $row[is_enabled];               
                                              
                if ($is_enabled = 1) {
                       DB_query("DELETE FROM {$_TABLES['blocks']} WHERE type ='normal' && title ='Weather'",1); 
                }
   	}        
   	echo COM_refresh('index.php');   	

}

$admin_page = 'index.php';
function weatheradmin($region, $tp){
	
	global $_TABLES, $_USER, $_CONF, $strings, $HTTP_USER_AGENT;	
	$siteurl = $_CONF['site_url'];
	$set = $strings['set_button'];
	$add = $strings['add_button'];
	$go = $strings['go_button'];	
	
	// Browser Check
	if(@eregi("(opera) ([0-9]{1,2}.[0-9]{1,3}){0,1}",$HTTP_USER_AGENT,$match) || @eregi("(opera/)([0-9]{1,2}.[0- 9]{1,3}){0,1}",$HTTP_USER_AGENT,$match))
	{
	$BName= "Opera"; $BVersion=$match[2];
	}
	elseif(eregi("(msie) ([0-9]{1,2}.[0-9]{1,3})",$HTTP_USER_AGENT,$match))
	{
	$BName = "MSIE"; $BVersion=$match[2];
	}
		
		
	//phpblock_debugWrite(" Region is: " .$region);	
	$sql = "select metar,location from {$_TABLES['weather']} where wdefault=1";
        $row = DB_fetchArray(DB_query($sql));
	$metar = $row[metar];	
	
        $return .= "<img src=\"$siteurl/weather/images/weather.gif\">";
	$return .= "<b><font size=\"4\">&nbsp;"; 
        $return .= $strings['plugin_admin'];
	$return .= "</b></font><p>"; 
        $return .= $strings['admin_note'];
	$return .= "<p>";
        $location = $row[location];	    	           
	  if (empty($metar)) {	           
	          $return .= $strings['set_global'];
	  } else {
	         $return .= $strings['global'];	     
	         $return .= " <b>$location</b>.";
         }     
	
	$return .= "<P>";			
	$return .= "<form action=\"$admin_page?op=addlocation&region=$region&tp=$tp\" method=\"post\">";
        $return .= "<div align=left>";
        $return .= $strings['add'];
        $return .= "<BR></b>";
        $return .= "<table><tr><td width=100>";
        $return .= $strings['city'];
        $return .= "</td><td><input type=\"text\" name=\"name\" size=\"30\"></td></tr><tr>";
        $return .= "<td>";
        $return .= $strings['zip'];
        $return .= "</td><td><input type=\"text\" name=\"zip\" size=\"30\"></td></tr><tr>";
        $return .= "<td>";
        $return .= $strings['region'];
        $return .= "</td><td><input type=\"text\" name=\"region\" size=\"30\"></td></tr><tr>";
        $return .= "<td>";
        $return .= $strings['metar'];
        $return .= "</td><td><input type=\"text\" name=\"metar\" size=\"30\"></td></tr><tr>";
        $return .= "<td>";
        $return .= $strings['show_forecast'];
        $return .= "</td><td><input type=\"radio\" name=\"forecast\" value=1>";
        $return .= $strings['yes'];
        $return .= "<input type=\"radio\" name=\"forecast\" value=0 checked>";
        $return .= $strings['no'];
        $return .= "</td></tr><tr>";	        	        
 	$return .= "<td><input type=\"submit\" value=\"$add\"></td><td>&nbsp;</td></tr></table>";
        $return .= "</div>";
        $return .= "</form>";
        $return .= "<div align=left><b>";
        $return .= $strings['tools'];
        $return .= "<BR></b>";
        $return .= $strings['cache'];
        $return .= "<BR></b>";
        $return .= "<div align=left>";
        $return .= $strings['click'];	        
        $return .= " <a href=\"flush_cache.php\">";
        $return .= $strings['here'];	        
        $return .= "</a> ";   
        $return .= $strings['update'];	        	         
        $return .= "<BR><br>";      
        $return .= $strings['contest'];
        $return .= "<BR></b>";
        $return .= "<div align=left>";
        $return .= $strings['click'];	        
        $return .= " <a href=\"connectivity_test.php\">";
        $return .= $strings['here'];	        
        $return .= "</a> ";   
        $return .= $strings['connection'];	        	         
        $return .= "<BR><br>";        
        $return .= $strings['speedtest'];
        $return .= "<BR></b>";
        $return .= "<div align=left>";
        $return .= $strings['click'];	        
        $return .= " <a href=\"speed_test.php\">";
        $return .= $strings['here'];	        
        $return .= "</a> ";   
        $return .= $strings['speed'];	        	         
        $return .= "<BR><br>";	        
        $return .= $strings['datatest'];
        $return .= "<BR></b>";
        $return .= "<div align=left>";
        $return .= $strings['data'];
        $return .= "<form method=\"POST\" action=\"array.php\">";
	$return .= $strings['testdata'];
	$return .= "<INPUT type=\"text\" name=\"metar\">";
	$return .= "&nbsp;<INPUT type=\"submit\" value=\"Submit\">";	
	$return .= "</form>";               	         
        $return .= "<BR>";	    	               
        $return .= "<form action=\"$admin_page?tp=$tp&region=$region\" method=\"post\">";
        $return .= "<b>";
        $return .= $strings['region_select'];
        $return .= "<br></b>";	        
	$sql = "select distinct region from {$_TABLES['weather']} order by region";	
	$query = DB_query($sql);
	if ($BName=='MSIE' || $BName=='Opera') {	
	$return .= $strings['region']; 
	$return .= ":<select name=\"region\" onChange=\"submit()\">";
	$return .= "<option selected>";
	$return .= $strings['region_form'];
	$return .= "</option>";
	while ($row = DB_fetchArray($query)) {
		$return .= "<option value=\"$row[region]\">$row[region]</option>";
	}	
	$return .= "</select>";
	} else {
        $return .= $strings['region']; 
	$return .= ":<select name=\"region\">";
	$return .= "<option selected>";
	$return .= $strings['region_form'];
	$return .= "</option>";
	while ($row = DB_fetchArray($query)) {
		$return .= "<option value=\"$row[region]\">$row[region]</option>";
	}	
	$return .= "</select>";
	$return .= "&nbsp;<INPUT TYPE=SUBMIT VALUE=\"$go\">";
	}
	$return .= "<input type=\"hidden\" name=\"send\" value=\"region\">";
	$return .= "</form>";       	        
        $return .= "<table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"1\">\n";					        		
	 
	if (!empty($region)) {
        $return .= "<b>";
        $return .= $strings['select'];
        $return .= "&nbsp;$region&nbsp;";
        $return .= $strings['location'];
        $return .= "</b><br>";
        //$return.= "<tr><td colspan=\"3\"><hr width=\"100%\" size=\"2\" noshade=\"noshade\"></td></tr>";	
	//$return .= "</table>\n";
	$return.= "<hr width=\"100%\" size=\"2\" noshade=\"noshade\">";	
	$return .= "<table width=\"100%\" border=\"1\" cellspacing=\"0\" cellpadding=\"1\">\n";
	$sql = "select * from {$_TABLES['weather']} where region='$region' order by location";
	$result = DB_query($sql);
	while ($row = DB_fetchArray($result)){
		$metar = $row[metar];
		$location = $row[location];
		$zip = $row[zip];
		$global_default = $row[wdefault];
		$wforecast = $row[wforecast];
		if ($row[metar] == $_USER['weather_metar']) {
			$user_default = $row[location];
		} else {
			$user_default = '';
		}
		$return .= "<tr><td width=\"250\">\n";
		$return .= "$location</td>\n";
		$return .= "<td>\n";
		$return .= "<a href=\"$admin_page?op=editlocation&location=$location&region=$region&tp=$tp\">";
		$return .= $strings['edit'];
		$return .= "</a>\n";
		$return .= "</td><td>\n";
		$return .= "<a href=\"$admin_page?op=deletelocation&location=$location&region=$region&tp=$tp\">";
		$return .= $strings['delete'];
		$return .= "</a>\n";
		$return .= "</td><td>\n";		
		if ($wforecast==1){
		     $return .= "<a href=\"$siteurl/weather/index.php?zip=$zip\">";
		     $return .= $strings['show'];
		     $return .= "</a>\n";
		} else {
		     $return .= "<a href=\"$siteurl/weather/weather_details.php?metar=$metar&tp=$tp&region=$region\">";
		     $return .= $strings['show'];
		     $return .= "</a>\n";
		}     	     
		$return .= "</td><td>";
		if ($global_default) {
			$return .= "<font color=\"#ff0000\"><b>";
			$return .= $strings['global_default'];
			$return .= "</b></font>&nbsp;&nbsp;\n";
		} else {
			$return .= "<a href=\"$admin_page?op=set_as_global_default&metar=$metar&region=$region&tp=$tp\">";
			$return .= $strings['make_global'];
			$return .= "</a><BR>\n";
			}
		} 
		$return .="</td></tr>";
	   }      
	return $return;
}

function addlocation($name,$region,$zip,$metar,$forecast){
	global $_TABLES;	
	$return = '';
	$sql = "insert into {$_TABLES['weather']} values('','$metar','$name','$region','$zip','$forecast','0')";
	$result = DB_query($sql);
	if (!$result) {
		$return .= DB_error();
		echo $return;
		exit();
	}
}


function set_global_default_tp($default_tp){
	global $_TABLES, $_USER;
	
	$sql = "update {$_TABLES['userprefs']} set weather_tp='" . $default_tp . "' where `uid` = 1";
	DB_query($sql);		
	
	
}

function set_as_global_default($metar){	
	global $_TABLES;
		
	$sql = "update {$_TABLES['weather']} set wdefault='0' where wdefault='1'";
	DB_query($sql);
	
	$sql = "update {$_TABLES['weather']} set wdefault='1' where metar='$metar'";
	DB_query($sql);	
	
}

function editlocation($location,$region){
	global $_TABLES, $strings;
	
	$update = $strings['update_button'];	
	$return = '';	
	$return .= "<form action=\"$admin_page?op=updatelocation&region=$region&tp=$tp\" method=\"post\">";
	$return .= "<input type=\"hidden\" name=\"location\" value=\"$location\">";
	$sql = "select metar,region,zip,wforecast from {$_TABLES['weather']} where location='$location'";
	$row = DB_fetchArray(DB_query($sql));	
	$return .= "<center><table><tr><td></td><td><b>";
	$return .= $strings['edit_entry'];
	$return .= "</b></td></tr>";
	$return .= "<tr><td>";
	$return .= $strings['change'];
	$return .= "&nbsp;<b>$location</b>&nbsp;";
	$return .= $strings['to'];
	$return .= "</td><td>";
	$return .= "<input type=\"text\" name=\"changeloc\" value=\"$location\" size=\"30\"><BR>";
	$return .= "</td><tr>";	
	if (!empty($row[zip])){
	$return .= "<tr><td>";
	$return .= $strings['change'];
	$return .= "&nbsp;<b>$row[zip]</b>&nbsp;";
	$return .= $strings['to'];
	$return .= "</td><td>";
	$return .= "<input type=\"text\" name=\"changezip\" value=\"$row[zip]\" size=\"30\">";
	$return .= "</td></tr>";
	}
	$return .= "<td>";
	$return .= $strings['change'];
	$return .= "&nbsp;<b>$row[region]</b>&nbsp;";
	$return .= $strings['to'];
	$return .= "</td><td>";
	$return .= "<input type=\"text\" name=\"changereg\" value=\"$row[region]\" size=\"30\"><BR>";
	$return .= "</td></tr>";
	$return .= "<td>";
	$return .= $strings['change'];
	$return .= "&nbsp;<b>$row[metar]</b>&nbsp;";
	$return .= $strings['to'];
	$return .= "</td><td>";
	$return .= "<input type=\"text\" name=\"changemet\" value=\"$row[metar]\" size=\"30\">";
	$return .= "</td></tr>";
	if ($row[wforecast]==1){
	$return .= "<td>";
	$return .= $strings['change'];
	$return .= "&nbsp;<b>";
	$return .= $strings['yes'];
	$return .= "</b>&nbsp;";
	$return .= $strings['to'];
	$return .= "</td><td>";
	$return .= "<input type=\"radio\" name=\"changefor\" value=0>";
	$return .= $strings['no'];
	$return .= "<input type=\"radio\" name=\"changefor\" value=1 checked>";
	$return .= $strings['yes'];
	$return .= "<BR>";
	$return .= "</td></tr>";
	} else {
	$return .= "<td>";
	$return .= $strings['change'];
	$return .= "&nbsp;<b>";
	$return .= $strings['no'];
	$return .= "</b>&nbsp;";
	$return .= $strings['to'];
	$return .= "</td><td>";
	$return .= "<input type=\"radio\" name=\"changefor\" value=1>";
	$return .= $strings['yes'];
	$return .= "<input type=\"radio\" name=\"changefor\" value=0 checked>";
	$return .= $strings['no'];
	$return .= "<BR>";
	$return .= "</td></tr>";
	}	
	$return .= "<tr><td></td><td><input type=\"submit\" value=\"$update\"></td></tr>";
	$return .= "</table></form></center><hr>";
	return $return;
}

function updatelocation($location,$changereg,$changeloc,$changezip,$changemet,$changefor){
	global $_TABLES;
	
	//phpblock_debugWrite(" chg region is: " .$changereg);
	//phpblock_debugWrite(" chg loc: " .$changeloc);
	//phpblock_debugWrite(" chg met: " .$$changemet);
	
	$sql = "update {$_TABLES['weather']} set metar='$changemet',location='$changeloc',region='$changereg',zip='$changezip', wforecast='$changefor' where location='$location'";
	DB_query($sql);
}

function deletelocation($location,$region){
	
	global $strings;
	
	$yes = $strings['yes'];
	$return = '';
	$return .= "<div align=\"center\" class=\"orangetext2\"><b>";
	$return .= $strings['remove'];
	$return .= "</div></b><p>";
	$return .= "<table align=center><tr>";
	$return .= "<form action=\"$admin_page?op=do_deletelocation&region=$region&tp=$tp\" method=\"post\">";
	$return .= "<input type=\"hidden\" name=\"location\" value=\"$location\">";
	$return .= "<td valign=center>";
	$return .= "<b>";
	$return .= $strings['confirm_del'];
	$return .= "&nbsp;$location?</b>";
	$return .= "</td><tr><td align=left>";
	$return .= "<input type=\"submit\" value=\"$yes\"> </td><td align=right><a href=\"javascript:history.go(-1);\">";
	$return .= $strings['back'];
	$return .= "</a></td>";
	$return .= "</form>";
	$return .= "</tr></table><hr>";
	return $return;
}

function do_deletelocation($location){
	global $_TABLES;
	
	$sql = "delete from {$_TABLES['weather']} where location='$location'";
	DB_query($sql);
}

switch ($op) {

 case "set_as_user_default":
	 set_as_user_default($metar); 
	 break;
 case "set_default_tp":
	 set_default_tp($tp);
	 break;
case "set_global_default_tp":
	if (!SEC_inGroup('Weather Admin')) {
		$display .= "<strong>";
		$strings['warn'];
		$display .= "</strong>";
	} else {
		set_global_default_tp($default_tp);
	}	
	 break;	 
 case "set_as_global_default":
	if (!SEC_inGroup('Weather Admin')) {
		$display .= "<strong>";
		$strings['warn'];
		$display .= "</strong>";
	} else {
		set_as_global_default($metar);
	}
	 break;
 case "editlocation":
	if (!SEC_inGroup('Weather Admin')) {
		$display .= "<strong>";
		$strings['warn'];
		$display .= "</strong>";
	} else {
		$display .= editlocation($location,$region);
	}
	 break;
 case "updatelocation":
	if (!SEC_inGroup('Weather Admin')) {
		$display .= "<strong>";
		$strings['warn'];
		$display .= "</strong>";
	} else {
		updatelocation($location,$changereg,$changeloc,$changezip,$changemet,$changefor);
	}
	break;
 case "deletelocation":
	if (!SEC_inGroup('Weather Admin')) {
		$display .= "<strong>";
		$strings['warn'];
		$display .= "</strong>";
	} else {
		$display .= deletelocation($location,$region);
	}
	 break;
 case "do_deletelocation":
	if (!SEC_inGroup('Weather Admin')) {
		$display .= "<strong>";
		$strings['warn'];
		$display .= "</strong>";
	} else {
		do_deletelocation($location);
	}
	break;
 case "addlocation":
	if (!SEC_inGroup('Weather Admin')) {
		$display .= "<strong>";
		$strings['warn_2'];
		$display .= "</strong><p>";
	} else {
		addlocation($name,$region,$zip,$metar,$forecast);
	}
	break;
}


if (empty($region)){
$metar =($_USER['weather_metar']);	
$sql = "select region from {$_TABLES['weather']} where metar='$metar'";
	$row = DB_fetchArray(DB_query($sql));	
	$region = $row[region];	
}

if (empty($tp)) {
	if ($_USER['weather_tp']){
	  $tp = $_USER['weather_tp'];
	} else {
	   $tp = $_CONF['default_tp'];
	}  
} 

$display .= weatheradmin($region, $tp);
$display .= "<tr><td colspan=\"6\"></td></tr></table>";
//$T->parse('output','admin');
//$display .= $T->finish($T->get_var('output'));
$display .= COM_endBlock();
$display .= COM_siteFooter(false);
echo $display;

?>
