<?php
if (empty($HTTP_GET_VARS['batches'])) {
  $batches = 1;
} else {
  $batches = $HTTP_GET_VARS['batches'];
}
$count = $batches*32;


error_reporting(E_ALL);

/* This is 256 more or less randomly picked ICAOs from stations.csv.
   The ICAOs are grouped in batches of 32: */
$icaos = array(
  array('DABS', 'SARC', 'SARE', 'UGEE', 'YSDU', 'LOWG', 'VGZR', 'EBCV',
        'TXKF', 'SLRY', 'SLVM', 'FBTE', 'SBBR', 'SBFN', 'SBLO', 'SBPP',
        'SBSC', 'SBUR', 'VDPP', 'CYZS', 'CYGL', 'CYZT', 'CYYN', 'MWCR',
        'SCTE', 'ZGSZ', 'SKCG', 'FZAA', 'LDSP', 'MUMZ', 'LKMT', 'EKSN'),
  array('HDAM', 'SEQU', 'MSSS', 'EFKK', 'LFSB', 'LFLB', 'LFOH', 'LFSF',
        'LFPO', 'LFCG', 'SOCA', 'EDDT', 'EDFH', 'EDLN', 'LXGB', 'LGKR',
        'LGZA', 'MGGT', 'MHCA', 'MHYR', 'VECC', 'WRRR', 'OIMM', 'LIEA',
        'LIMU', 'LIPK', 'LIBN', 'LIMN', 'LIMH', 'LIPQ', 'LIPI', 'RJCA'),
  array('RJFF', 'RJDB', 'RJSU', 'RJOM', 'ROAH', 'RJKB', 'RJNY', 'RJOR',
        'RJTY', 'HKGA', 'HKMB', 'HKWJ', 'RKPK', 'RKPU', 'HLLT', 'WMKK',
        'FIMP', 'MMCS', 'MMHO', 'MMMY', 'MMSD', 'MMPN', 'GMMN', 'EHKD',
        'EHVL', 'NZWN', 'ENAN', 'ENFL', 'ENLI', 'ENFB', 'ENZV', 'OOSA'),
  array('MPMG', 'SPEO', 'SPJA', 'EPGD', 'LPLA', 'OTBD', 'UHMD', 'ULLI',
        'FPST', 'OEGN', 'OERY', 'GOTT', 'AGGH', 'FAPB', 'LEGE', 'LEMG',
        'LEZL', 'FDMS', 'ESSB', 'LSZH', 'RCFN', 'RCDC', 'HTIR', 'HTSO',
        'TTCP', 'DTTX', 'LTBG', 'LTBJ', 'LTBQ', 'UKLL', 'EGAA', 'EGSC'),
  array('EGLF', 'EGKK', 'EGHD', 'EGBJ', 'KABI', 'KALS', 'KAIA', 'PAKP',
        'KAIG', 'KHZY', 'KAUO', 'KBFL', 'KBOW', 'KBPT', 'KVBT', 'KBHM',
        'KBNW', 'KBDR', 'KBCE', 'KBRL', 'KP38', 'PACZ', 'KCID', 'KCRW',
        'KPWK', 'KLUK', 'KCQC', 'KCOS', 'KCCR', 'KCVO', 'K0V1', 'KDMA'),
  array('KDFI', 'KDET', 'KDOV', 'KDYR', 'KECG', 'PAEM', 'KEVM', 'KFNB',
        'KFIT', 'KFNL', 'KFLV', 'KFSM', 'KFKL', 'KGAG', 'KAKH', 'KGLD',
        'KGPZ', 'KGMU', 'PAGS', 'K4HV', 'KHDN', 'KHKY', 'KHDO', 'KHOU',
        'KHCD', 'KEYE', 'KJAC', 'KJHW', 'PHOG', 'KEAR', 'KNQX', 'KTYS'),
  array('KLCH', 'KLNS', 'KLWM', 'KLWS', 'KLIT', 'KLAX', 'KHFF', 'KP75',
        'KMWA', 'KMHR', 'KMCB', 'KP28', 'PAMR', 'KMIV', 'KMIB', 'KMLI',
        'KMXO', 'KVAY', 'KMIE', 'KAPC', 'KHVN', 'KEWR', 'PAOM', 'PAQT',
        'KPWA', 'KORE', 'KOWA', 'KPAO', 'KSFZ', 'PAPG', 'KPIB', 'KPIH'),
  array('PAAP', 'KPTW', 'KPGD', 'KRWL', 'KRIC', 'KRKS', 'KROX', 'KE74',
        'K27U', 'KMYF', 'KSFM', 'PASA', 'KSEG', 'PASY', 'KBFW', 'KU78',
        'KSPF', 'KPHN', 'KSBS', 'KTCM', 'KTPL', 'PATG', 'KTVC', 'KTCL',
        'PAVD', 'KVEL', 'PAFB', 'KRYV', 'KWYS', 'PAWR', 'KILL', 'KINK'));



$lib_common = '../../../lib-common.php';
include($lib_common);
echo COM_siteHeader();
echo COM_startBlock('Speed Test');
include('../../../weather/phpweather.inc'); 
// Only let admin users access this page
if (!SEC_hasRights('weather.admin')) {    
// Someone is trying to illegally access this page
    COM_errorLog("Someone has tried to illegally access the Weather plugin install documentation.  User id: {$_USER['uid']}, Username: {$_USER['username']}, IP: $REMOTE_ADDR",1);
    $display = COM_siteHeader();
    $display .= COM_startBlock($LANG_GW00['access_denied']);
    $display .= $LANG_GW00['access_denied_msg'];
    $display .= COM_endBlock();
    $display .= COM_siteFooter(true);
    echo $display;
    exit;
}


echo "<p>This page runs a test to determine how long it takes to access the data in the
database. It will meassure the time it takes for the Geeklog Weather Plugin to retrieve 
and display a large number of METARs.</p>";

echo "<p>We will now time the Geeklog Weather Plugin while it retrieves and parses";
echo $count;

echo "different METARs. This will take a long time at first
because the Geeklog Weather Plugin has to retrieve the METARs from the Internet, but
the second time you use this page it should go much faster because the
METARs can be retrieved from the database.</p>";


echo "<p>Select the number of METARs to use:";
echo "<a href=\"";
echo $PHP_SELF;
echo "?batches=1\">32</a>";

echo "&nbsp;";
echo "<a href=\"";
echo $PHP_SELF;
echo "?batches=2\">64</a>";

echo "&nbsp;";
echo "<a href=\"";
echo $PHP_SELF;
echo "?batches=3\">96</a>";

echo "&nbsp;";
echo "<a href=\"";
echo $PHP_SELF;
echo "?batches=4\">128</a><p>";

echo "<h2>Processing " . ($batches * 32) . " METARs</h2>\n";
flush();

$start_time = explode(' ', microtime());
require_once('../../../weather/phpweather.inc');

for ($i = 0; $i < $batches; $i++) {
  for ($j = 0; $j < 32; $j++) {
   
    /* We play a little with the objects - the output is just
       discarded: */
    $output = "\n<!-- " .  process_metar(get_metar($metar)) . " -->\n";
    
  }
  echo "<p>Processed " . (($i+1) * 32) . " METARs...</p>\n";
  flush();
}

$end_time = explode(' ', microtime());

$diff = ($end_time[0] + $end_time[1]) - ($start_time[0] + $start_time[1]);

echo "<p>Total time used to process $count METARs: <b>" .
  number_format($diff * 1000, 0) . " ms</b>.</p>\n";

echo '<p>Time used per METAR: <b>' .
  number_format($diff * 1000 / ($batches*32), 1) . " ms</b>.</p>\n"; 
  
echo COM_endBlock();
echo COM_siteFooter(false);  

?>

