<?
function get_from_nws($metar, $tp)
{

include('phpweather.inc');

global $_CONF, $_TABLES, $_USER, $HTTP_USER_AGENT, $_GW_showform, $strings;

$weather = get_metar($metar);
$data = process_metar($weather);
$image = get_sky_image($data);
$desc = get_phenomena_group($data);

//phpblock_debugWrite(" Desc is: " .$desc);

$sql = "select timestamp from {$_TABLES['weather_cache']} where station='$metar'";
	$row = DB_fetchArray(DB_query($sql));
	$timestamp = $row[timestamp];

$sql = "select location,region,zip,wforecast from {$_TABLES['weather']} where metar='$metar'";
	$row = DB_fetchArray(DB_query($sql));
	$location = $row[location];	
	$region = $row[region];
	$zip = $row[zip];
	$wforecast = $row[wforecast];
	
//phpblock_debugWrite(" Location is: " .$location);
//phpblock_debugWrite(" Region is: " .$region);	

$date_unixtime = time();
$date = date('YmdHis', $date_unixtime);
$cache_age = date('YmdHi', $timestamp);
$minutes_old = round(($date-$timestamp)/60);
$hours_old = round(($minutes_old/60));
//phpblock_debugWrite(" Hours old is: " .$hours_old);
//phpblock_debugWrite(" Minutes old is: " .$minutes_old);
//phpblock_debugWrite(" Time now is: " .$date);
//phpblock_debugWrite(" Cahce age is: " .$timestamp);


//Browser check
if(@eregi("(opera) ([0-9]{1,2}.[0-9]{1,3}){0,1}",$HTTP_USER_AGENT,$match) || @eregi("(opera/)([0-9]{1,2}.[0- 9]{1,3}){0,1}",$HTTP_USER_AGENT,$match))
{
$BName= "Opera"; $BVersion=$match[2];
}
elseif(eregi("(msie) ([0-9]{1,2}.[0-9]{1,3})",$HTTP_USER_AGENT,$match))
{
$BName = "MSIE"; $BVersion=$match[2];
}

if ($tp=='F') {
     $temp = $data['temp_f'];
     $deg = "&nbsp;&deg;F";
} 

if ($tp=='C') {
     $temp = $data['temp_c'];
     $deg = "&nbsp;&deg;C";
}


/* Cloudlayers. */
  if($data['cloud_layer1_condition'] == 'CAVOK') {
    $sky_str = $strings['sky_cavok'];
  } elseif (isset($data['cloud_layer1_altitude_ft'])) {
    
    if ($data['cloud_layer1_condition'] == '') {
    $sky_str = sprintf($strings['sky_str_format4'],  
                       $data['cloud_layer1_altitude_m'],
                       $data['cloud_layer1_altitude_ft']);
                       
    //phpblock_debugWrite(" Sky var1: " .$sky_str);                       
    } else {
    $sky_str = sprintf($strings['sky_str_format4'],    
                       $data['cloud_layer1_condition'],
                       $data['cloud_layer1_altitude_m'],
                       $data['cloud_layer1_altitude_ft']);
                       
   //phpblock_debugWrite(" Sky var2: " .$sky_str);                       
   }                      	  	                                    
    if(isset($data['cloud_layer2_altitude_ft'])) {
      if(isset($data['cloud_layer3_altitude_ft'])) {
      	$sky_str .= sprintf($strings['sky_str_format2'],
                            $data['cloud_layer2_condition'],
                            $data['cloud_layer2_altitude_m'],
                            $data['cloud_layer2_altitude_ft'],
                            $data['cloud_layer3_condition'],
                            $data['cloud_layer3_altitude_m'],
                            $data['cloud_layer3_altitude_ft']);
                            
      //phpblock_debugWrite(" Sky var3: " .$sky_str);                            
      } else {
        $sky_str .= sprintf($strings['sky_str_format3'],
                            $data['cloud_layer2_condition'],
                            $data['cloud_layer2_altitude_m'],
                            $data['cloud_layer2_altitude_ft']);
                            
       //phpblock_debugWrite(" Sky var4: " .$sky_str);                            
      }
    }
  } else {
    $sky_str = $strings['sky_str_clear'];
  }
  $sky_str .= '.';
  
  
  /* Visibility. */
  if(isset($data['visibility_miles'])) {
    $visibility = sprintf($strings['visibility_format'],
                          $data['visibility_km'],
                          $data['visibility_miles']);
  } else {
    $visibility = '';
  }

  /* Wind. */
  if (isset($data['wind_meters_per_second']) &&
      $data['wind_meters_per_second'] > 0) {
    $wind_str = sprintf($strings['wind_str_format1'],
                        $data['wind_meters_per_second'],
                        $data['wind_miles_per_hour']);
    if (isset($data['wind_gust_meters_per_second']) &&
        $data['wind_gust_meters_per_second'] > 0) {
      $wind_str .= sprintf($strings['wind_str_format2'],
                           $data['wind_gust_meters_per_second'],
                           $data['wind_gust_miles_per_hour']);
    }    
  }

  /* Windchill */
  if (isset($data['windchill_c'])) {
    $windchill_str = sprintf($strings['windchill'],
                             $data['windchill_c'],
                             $data['windchill_f']);
  } else {
    $windchill_str = '';
  }

  /* Precipitation. */
  $prec_str = '';
  if (isset($data['precip_in'])) {
    $prec_str .= pretty_print_precip($data['precip_mm'], $data['precip_in']) .
      $strings['precip_last_hour'];
  }
  if (isset($data['precip_6h_in'])) {
    $prec_str .= pretty_print_precip($data['precip_6h_mm'],
                                     $data['precip_6h_in']) .
      $strings['precip_last_6_hours'];
  }
  if (isset($data['precip_24h_in'])) {
    $prec_str .= pretty_print_precip($data['precip_24h_mm'],
                                     $data['precip_24h_in']) .
      $strings['precip_last_24_hours'];
  }
  if (isset($data['snow_in'])) {
    $prec_str .= sprintf($strings['precip_snow'],
                         $data['snow_mm'], $data['snow_in']);
  }


//phpblock_debugWrite(" Desc is: " .$desc);
//phpblock_debugWrite(" Visibility is: " .$visibility);
//phpblock_debugWrite(" Wind is: " .$wind_str);
//phpblock_debugWrite(" Sky is: " .$sky_str);

//pick the best description:  Cloudlayers, Visibility, Windchill, or Precipitation
if ($desc=='None') {$desc = $visibility;}	
if ($desc=='Thun') {$desc = $wind_str;}
if ($desc=='Fog') {$desc = $visibility;}
if ($desc=='Snow') {$desc = $windchill_str;}

if ($desc=='Hail') {
  $desc = $prec_str;
     if (empty($desc)){
     	$desc = $visibility;
     }
}	

if (($desc=='-Rain') || ($desc=='Rain')){
  $desc = $prec_str;
     if (empty($desc)){
     	$desc = $visibility;
     }
}

if (($desc=='+Rain') || ($desc=='Rain')){
  $desc = $prec_str;
     if (empty($desc)){
     	$desc = $visibility;
     }
}


//no data?
if ($desc=='.') {$desc = '';}
if (empty($desc)) {$desc = '';}
if (empty($temp)){
$error = $strings['no_data'];
$settings = $strings['settings'];
$register = $strings['register'];
if (($_USER['uid'] > 0)) {
$desc = "$error $settings";
} else {
$desc = "$error $register";
}	
$image = '/images/temp_nodata.gif';
$temp = '';
$deg = '';
$location = '';
}	
 
$boxtitle .="<b>$location</b><br>";
$boxtitle .= "<table width=\"100%\" border=\"0\" cellspacing=\"1\" cellpadding=\"1\">";

//if cache older than 1 hour
//if ($hours_old > 1) {	
//     $boxtitle.= "<br><font size=\"-2\">Last updated $hours_old hours ago</font>.<br>";
//}

//phpblock_debugWrite(" Image is: " .$image);
$boxtitle .="<tr><td align=\"right\">\n";
$boxtitle .="<font size=\"5\">". $temp . "";
$boxtitle .="</font>" . $deg ."";
$boxtitle .="</td><td>";
$boxtitle .= "<img src=\"" . $_CONF['site_url'] . "/weather/" . $image . "\">";
$boxtitle .= "</td></tr>";
$boxtitle .= "<tr><td colspan=\"2\">";
$boxtitle .= "$desc";
$boxtitle .= "</td></tr></table>";

if (empty($desc)){
$boxtitle .= "<br><table width=\"100%\" border=\"0\" cellspacing=\"1\" cellpadding=\"1\">";
}
if (!empty($desc)){
$boxtitle .= "<p><table width=\"100%\" border=\"0\" cellspacing=\"1\" cellpadding=\"1\">";
}

if ($wforecast==1){	    
$boxtitle .= "<tr align=left><td>";
$boxtitle .= "<a href=\"" . $_CONF['site_url'] . "/weather/index.php?zip=" . $zip . "\">";
$boxtitle .= $strings['forecast'];
$boxtitle .= "</td>";
} else {
$boxtitle .= "<tr align=left><td>";
$boxtitle .= "<a href=\"" . $_CONF['site_url'] . "/weather/weather_details.php?metar=" . $metar . "&tp=" .$tp. "&region=" . $region ."\">";
$boxtitle .= $strings['details'];
$boxtitle .= "</td>";
}	

if (($_USER['uid'] > 1)) {
$boxtitle .="<td align=right>";
$boxtitle .= "<a href=\"" . $_CONF['site_url'] . "/weather/admin.php?tp=$tp&region=$region\">";
$boxtitle .= $strings['configure'];		
$boxtitle .= "</td>";
}
$boxtitle .= "</tr>";
$boxtitle .= "</td></tr>\n";
$boxtitle .= "</table>";	

if ($wforecast==1 && $_GW_showform ==1){
	if ($BName=='MSIE' || $BName=='Opera') {			
	$go = $strings['go_button'];
	$sql = "select zip,location from {$_TABLES['weather']} where wforecast='1' order by location";	
	$query = DB_query($sql);	
	$boxtitle.= "<form action=\"" . $_CONF['site_url'] . "/weather/index.php\" method=\"post\">";
	$boxtitle.= $strings['more_forecast'];
	$boxtitle.= "<br><br>";
	$boxtitle .= "<table width=\"100%\" border=\"0\"><tr><td>";
	$boxtitle.= $strings['city_form2'];
	$boxtitle.= "</td></tr><tr><td><select name=\"zip_code\" onChange=\"submit()\">";
	$boxtitle.= "<option selected>";
	$boxtitle.= $strings['city_form'];
	$boxtitle.="</option>";
	while ($row = DB_fetchArray($query)) {
			$boxtitle.= "<option value=\"$row[zip]\">$row[location]</option>";
	       }
	$boxtitle.= "</select></td></tr><tr><td><br>";
	$boxtitle.= $strings['search_form'];
	$boxtitle.= "</td></tr><tr><td><input type=\"text\" name=\"zip\" size=\"5\" maxlength=\"5\">";
	$boxtitle.= "&nbsp;<input type=\"submit\" value=\"$go\"></td></tr></table></form>";		

	} else {	
	
	$go = $strings['go_button'];
	$sql = "select zip,location from {$_TABLES['weather']} where wforecast='1' order by location";	
	$query = DB_query($sql);	
	$boxtitle.= "<form action=\"" . $_CONF['site_url'] . "/weather/index.php\" method=\"post\">";
	$boxtitle.= $strings['more_forecast'];
	$boxtitle.= "<br><br>";
	$boxtitle .= "<table width=\"100%\" border=\"0\"><tr><td>";
	$boxtitle.= $strings['city_form2'];
	$boxtitle.= "</td></tr><tr><td><select name=\"zip_code\">";
	$boxtitle.= "<option selected>";
	$boxtitle.= $strings['city_form'];
	$boxtitle.="</option>";
	while ($row = DB_fetchArray($query)) {
			$boxtitle.= "<option value=\"$row[zip]\">$row[location]</option>";
	       }
	$boxtitle.= "</select><input type=\"submit\" value=\"$go\"></td></tr><tr><td><br>";
	$boxtitle.= $strings['search_form'];
	$boxtitle.= "</td></tr><tr><td><input type=\"text\" name=\"zip\" size=\"5\" maxlength=\"5\">";
	$boxtitle.= "<br><input type=\"submit\" value=\"$go\"></td></tr></table></form>";
	}			
}

if ($wforecast!=1 && $_GW_showform ==1){
        if ($BName=='MSIE' || $BName=='Opera') {
	$go = $strings['go_button'];
	$sql = "select location,metar from {$_TABLES['weather']} where wforecast='0' order by location";	
	$query = DB_query($sql);		
	$boxtitle.= "<form action=\"" . $_CONF['site_url'] . "/weather/weather_details.php?tp=$tp\" method=\"post\">";		
	$boxtitle .= "<table width=\"100%\" border=\"0\"><tr><td>";
	$boxtitle.= $strings['more_locations'];
	$boxtitle.= "</td></tr><tr><td><select name=\"metar\" onChange=\"submit()\">";
	$boxtitle.= "<option selected>";
	$boxtitle.= $strings['city_form'];
	$boxtitle.="</option>";
	while ($row = DB_fetchArray($query)) {
			$boxtitle.= "<option value=\"$row[metar]\">$row[location]</option>";
	       }
	$boxtitle.= "</select></td></tr></table></form>";
	} else {
	$go = $strings['go_button'];
	$sql = "select location,metar from {$_TABLES['weather']} where wforecast='0' order by location";	
	$query = DB_query($sql);	
	$boxtitle.= "<form action=\"" . $_CONF['site_url'] . "/weather/weather_details.php?tp=$tp\" method=\"post\">";	
	$boxtitle .= "<table width=\"100%\" border=\"0\"><tr><td>";
	$boxtitle.= $strings['more_locations'];
	$boxtitle.= "</td></tr><tr><td><select name=\"metar\">";
	$boxtitle.= "<option selected>";
	$boxtitle.= $strings['city_form'];
	$boxtitle.="</option>";
	while ($row = DB_fetchArray($query)) {
			$boxtitle.= "<option value=\"$row[metar]\">$row[location]</option>";
	       }
	$boxtitle.= "</select><input type=\"submit\" value=\"$go\"></form></td></tr></table>";
	}			
}

return $boxtitle;

}	

function getweather($tp) 
{

global $_CONF, $_GW_default_tp, $_GW_show_stats, $strings, $_TABLES, $_USER, $_WEATHER_TIMER, $REMOTE_ADDR;

// if logged in user with weather pref
if ($_USER['weather_metar']) {
	
	if (empty($tp)){
	  if ($_USER['weather_tp']){  
	       $tp = $_USER['weather_tp'];
	     } else {
	        $tp = $_GW_default_tp;
	     }  
	}     
			
	$metar = $_USER['weather_metar'];
	//phpblock_debugWrite(" User temp: " .$tp);
	//phpblock_debugWrite(" User metar: " .$metar);	
}

if (!$_USER['weather_metar']) {
	 
	if(empty($tp)){
	    $tp = $_GW_default_tp;
	}	
	$sql = "select metar from {$_TABLES['weather']} where wdefault=1";
	$row = DB_fetchArray(DB_query($sql));
	$metar = $row[metar];
        //phpblock_debugWrite(" Anonymous temp: " .$tp);
	//phpblock_debugWrite(" Anonymous metar: " .$metar);
}

$boxtitle.= get_from_nws($metar, $tp);

if ($_GW_show_stats == 1){

// Code for Performance Monitor hack -- see squatty.com
/*$dayofweek=date("l");
$month=date("F");
$day=date("d");
$year=date("Y");
$hour=date("H");
$ip=$REMOTE_ADDR;
$block="weather";
$exetime = $_WEATHER_TIMER->stopTimer();

DB_query("INSERT INTO {$_TABLES['block_stats']} (exetime,ip,block,month,day,year,hour) VALUES ('$exetime','$ip','$block','$month','$day','$year','$hour')");
*/

//Block Timer Code
$boxtitle.= "<font size =-2><br>Created in <b>";
$boxtitle.= $_WEATHER_TIMER->stopTimer();
$boxtitle.= "</b> seconds.</font>";
}
return $boxtitle;

}

?>
